Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3633)
+++ palm/trunk/SOURCE/Makefile	(revision 3634)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# OpenACC port for SPEC
+# 
+# 3579 2018-11-29 15:32:39Z suehring
 # Dependency for check_parameters on nesting_offl_mod added
 # 
@@ -554,4 +557,5 @@
 	coriolis.f90 \
 	cpulog_mod.f90 \
+	cuda_fft_interfaces.f90 \
 	data_log.f90 \
 	data_output_2d.f90 \
@@ -919,4 +923,8 @@
 	mod_kinds.o \
 	modules.o
+cuda_fft_interfaces.o: \
+	cuda_fft_interfaces.f90 \
+	modules.o \
+	mod_kinds.o
 data_log.o: \
 	mod_kinds.o \
@@ -1042,4 +1050,5 @@
 	pmc_interface_mod.o
 fft_xy_mod.o: \
+	cuda_fft_interfaces.o \
 	mod_kinds.o \
 	modules.o \
Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 3633)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3589 2018-11-30 15:09:51Z suehring
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -1143,4 +1146,6 @@
 !--    beginning of prognostic_equations.
        IF ( ws_scheme_mom )  THEN
+          !$ACC KERNELS PRESENT(sums_wsus_ws_l, sums_wsvs_ws_l) &
+          !$ACC PRESENT(sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l)
           sums_wsus_ws_l = 0.0_wp
           sums_wsvs_ws_l = 0.0_wp
@@ -1148,8 +1153,11 @@
           sums_vs2_ws_l  = 0.0_wp
           sums_ws2_ws_l  = 0.0_wp
+          !$ACC END KERNELS
        ENDIF
 
        IF ( ws_scheme_sca )  THEN
+          !$ACC KERNELS PRESENT(sums_wspts_ws_l)
           sums_wspts_ws_l = 0.0_wp
+          !$ACC END KERNELS
           IF ( humidity       )  sums_wsqs_ws_l = 0.0_wp
           IF ( passive_scalar )  sums_wsss_ws_l = 0.0_wp
@@ -3300,4 +3308,5 @@
 
        CHARACTER (LEN = *), INTENT(IN)    ::  sk_char !< string identifier, used for assign fluxes to the correct dimension in the analysis array 
+       INTEGER(iwp) ::  sk_num !< integer identifier, used for assign fluxes to the correct dimension in the analysis array
        
        INTEGER(iwp) ::  i      !< grid index along x-direction
@@ -3320,7 +3329,17 @@
        REAL(wp) ::  ibit1  !< flag indicating 3rd-order scheme along x-direction
        REAL(wp) ::  ibit2  !< flag indicating 5th-order scheme along x-direction
+#ifdef _OPENACC
+       REAL(wp) ::  ibit0_l  !< flag indicating 1st-order scheme along x-direction
+       REAL(wp) ::  ibit1_l  !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp) ::  ibit2_l  !< flag indicating 5th-order scheme along x-direction
+#endif
        REAL(wp) ::  ibit3  !< flag indicating 1st-order scheme along y-direction
        REAL(wp) ::  ibit4  !< flag indicating 3rd-order scheme along y-direction
        REAL(wp) ::  ibit5  !< flag indicating 5th-order scheme along y-direction
+#ifdef _OPENACC
+       REAL(wp) ::  ibit3_s  !< flag indicating 1st-order scheme along y-direction
+       REAL(wp) ::  ibit4_s  !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp) ::  ibit5_s  !< flag indicating 5th-order scheme along y-direction
+#endif
        REAL(wp) ::  ibit6  !< flag indicating 1st-order scheme along z-direction
        REAL(wp) ::  ibit7  !< flag indicating 3rd-order scheme along z-direction
@@ -3330,20 +3349,57 @@
        REAL(wp) ::  flux_d !< 6th-order flux at grid box bottom
        REAL(wp) ::  u_comp !< advection velocity along x-direction
+#ifdef _OPENACC
+       REAL(wp) ::  u_comp_l !< advection velocity along x-direction
+#endif
        REAL(wp) ::  v_comp !< advection velocity along y-direction
+#ifdef _OPENACC
+       REAL(wp) ::  v_comp_s !< advection velocity along y-direction
+#endif
        
-       REAL(wp), DIMENSION(nzb:nzt)   ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt)   ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt)   ::  diss_t !< discretized artificial dissipation at rightward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt)   ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt)   ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt)   ::  flux_t !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
+       REAL(wp) ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
+       REAL(wp) ::  diss_t !< discretized artificial dissipation at rightward-side of the grid box
+       REAL(wp) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
+       REAL(wp) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp) ::  flux_t !< discretized 6th-order flux at rightward-side of the grid box
        
+       REAL(wp) ::  diss_s !< discretized artificial dissipation term at southward-side of the grid box
+       REAL(wp) ::  flux_s !< discretized 6th-order flux at northward-side of the grid box
+#ifndef _OPENACC
        REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local !< discretized artificial dissipation term at southward-side of the grid box
        REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local !< discretized 6th-order flux at northward-side of the grid box
+#endif
        
+       REAL(wp) ::  diss_l !< discretized artificial dissipation term at leftward-side of the grid box
+       REAL(wp) ::  flux_l !< discretized 6th-order flux at leftward-side of the grid box
+#ifndef _OPENACC
        REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local !< discretized artificial dissipation term at leftward-side of the grid box
        REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local !< discretized 6th-order flux at leftward-side of the grid box
+#endif
         
-
+       SELECT CASE ( sk_char )
+
+           CASE ( 'pt' )
+              sk_num = 1
+           CASE ( 'sa' )
+              sk_num = 2
+           CASE ( 'q' )
+              sk_num = 3
+           CASE ( 'qc' )
+              sk_num = 4
+           CASE ( 'qr' )
+              sk_num = 5
+           CASE ( 'nc' )
+              sk_num = 6
+           CASE ( 'nr' )
+              sk_num = 7
+           CASE ( 's' )
+              sk_num = 8
+           CASE ( 'aerosol_mass', 'aerosol_number', 'salsa_gas' )
+              sk_num = 9
+
+       END SELECT
+
+#ifndef _OPENACC
 !
 !--    Compute the fluxes for the whole left boundary of the processor domain.
@@ -3408,7 +3464,30 @@
 
        ENDDO
-
+#endif
+
+       !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, sk_num) &
+       !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
+       !$ACC PRIVATE(ibit0, ibit1, ibit2, ibit3, ibit4, ibit5) &
+       !$ACC PRIVATE(ibit0_l, ibit1_l, ibit2_l) &
+       !$ACC PRIVATE(ibit3_s, ibit4_s, ibit5_s) &
+       !$ACC PRIVATE(ibit6, ibit7, ibit8) &
+       !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
+       !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
+       !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
+       !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s) &
+       !$ACC PRESENT(advc_flags_1) &
+       !$ACC PRESENT(sk, u, v, w, u_stokes_zu, v_stokes_zu) &
+       !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
+       !$ACC PRESENT(tend) &
+       !$ACC PRESENT(hom(nzb+1:nzb_max,1,1:3,0)) &
+       !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
+       !$ACC PRESENT(sums_wspts_ws_l, sums_wssas_ws_l) &
+       !$ACC PRESENT(sums_wsqs_ws_l, sums_wsqcs_ws_l) &
+       !$ACC PRESENT(sums_wsqrs_ws_l, sums_wsncs_ws_l) &
+       !$ACC PRESENT(sums_wsnrs_ws_l, sums_wsss_ws_l) &
+       !$ACC PRESENT(sums_salsa_ws_l)
        DO  i = nxl, nxr
 
+#ifndef _OPENACC
           j = nys
           DO  k = nzb+1, nzb_max
@@ -3467,9 +3546,8 @@
 
           ENDDO
+#endif
 
           DO  j = nys, nyn
 
-             flux_t(0) = 0.0_wp
-             diss_t(0) = 0.0_wp
              flux_d    = 0.0_wp
              diss_d    = 0.0_wp
@@ -3481,6 +3559,6 @@
                 ibit0 = REAL( IBITS(advc_flags_1(k,j,i),0,1), KIND = wp )
 
-                u_comp    = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
-                flux_r(k) = u_comp * (                                        &
+                u_comp = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
+                flux_r = u_comp * (                                           &
                           ( 37.0_wp * ibit2 * adv_sca_5                       &
                       +      7.0_wp * ibit1 * adv_sca_3                       &
@@ -3497,5 +3575,5 @@
                                      )
 
-                diss_r(k) = -ABS( u_comp ) * (                                &
+                diss_r = -ABS( u_comp ) * (                                   &
                           ( 10.0_wp * ibit2 * adv_sca_5                       &
                        +     3.0_wp * ibit1 * adv_sca_3                       &
@@ -3512,10 +3590,52 @@
                                              )
 
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                ibit2_l = REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )
+                ibit1_l = REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )
+                ibit0_l = REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )
+
+                u_comp_l = u(k,j,i) - u_gtrans + u_stokes_zu(k)
+                flux_l = u_comp_l * (                                         &
+                                             ( 37.0_wp * ibit2_l * adv_sca_5  &
+                                          +     7.0_wp * ibit1_l * adv_sca_3  &
+                                          +              ibit0_l * adv_sca_1  &
+                                             ) *                              &
+                                          ( sk(k,j,i)   + sk(k,j,i-1)    )    &
+                                      -      (  8.0_wp * ibit2_l * adv_sca_5  &
+                                          +              ibit1_l * adv_sca_3  &
+                                             ) *                              &
+                                          ( sk(k,j,i+1) + sk(k,j,i-2)    )    &
+                                      +      (           ibit2_l * adv_sca_5  & 
+                                             ) *                              &
+                                          ( sk(k,j,i+2) + sk(k,j,i-3)    )    &
+                                               )
+
+                 diss_l = -ABS( u_comp_l ) * (                                &
+                                             ( 10.0_wp * ibit2_l * adv_sca_5  &
+                                          +     3.0_wp * ibit1_l * adv_sca_3  &
+                                          +              ibit0_l * adv_sca_1  &
+                                             ) *                              &
+                                          ( sk(k,j,i)   - sk(k,j,i-1) )       &
+                                      -      (  5.0_wp * ibit2_l * adv_sca_5  &
+                                          +              ibit1_l * adv_sca_3  &
+                                             ) *                              &
+                                         ( sk(k,j,i+1) - sk(k,j,i-2)  )       &
+                                      +      (           ibit2_l * adv_sca_5  &
+                                             ) *                              &
+                                          ( sk(k,j,i+2) - sk(k,j,i-3) )       &
+                                                        )
+#else
+                flux_l = swap_flux_x_local(k,j)
+                diss_l = swap_diss_x_local(k,j)
+#endif
+
                 ibit5 = REAL( IBITS(advc_flags_1(k,j,i),5,1), KIND = wp )
                 ibit4 = REAL( IBITS(advc_flags_1(k,j,i),4,1), KIND = wp )
                 ibit3 = REAL( IBITS(advc_flags_1(k,j,i),3,1), KIND = wp )
 
-                v_comp    = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
-                flux_n(k) = v_comp * (                                        &
+                v_comp = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
+                flux_n = v_comp * (                                           &
                           ( 37.0_wp * ibit5 * adv_sca_5                       &
                        +     7.0_wp * ibit4 * adv_sca_3                       &
@@ -3532,5 +3652,5 @@
                                      )
 
-                diss_n(k) = -ABS( v_comp ) * (                                &
+                diss_n = -ABS( v_comp ) * (                                   &
                           ( 10.0_wp * ibit5 * adv_sca_5                       &
                        +     3.0_wp * ibit4 * adv_sca_3                       &
@@ -3546,4 +3666,47 @@
                              ( sk(k,j+3,i) - sk(k,j-2,i) )                    &
                                              )
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                ibit5_s = REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )
+                ibit4_s = REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )
+                ibit3_s = REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )
+
+                v_comp_s = v(k,j,i) - v_gtrans + v_stokes_zu(k)
+                flux_s = v_comp_s * (                                         &
+                                             ( 37.0_wp * ibit5_s * adv_sca_5  &
+                                          +     7.0_wp * ibit4_s * adv_sca_3  &
+                                          +              ibit3_s * adv_sca_1  &
+                                             ) *                              &
+                                         ( sk(k,j,i)  + sk(k,j-1,i)     )     &
+                                       -     (  8.0_wp * ibit5_s * adv_sca_5  &
+                                          +              ibit4_s * adv_sca_3  &
+                                              ) *                             &
+                                         ( sk(k,j+1,i) + sk(k,j-2,i)    )     &
+                                      +      (           ibit5_s * adv_sca_5  &
+                                             ) *                              &
+                                        ( sk(k,j+2,i) + sk(k,j-3,i)     )     &
+                                             )
+
+                diss_s = -ABS( v_comp_s ) * (                                 &
+                                             ( 10.0_wp * ibit5_s * adv_sca_5  &
+                                          +     3.0_wp * ibit4_s * adv_sca_3  &
+                                          +              ibit3_s * adv_sca_1  &
+                                             ) *                              &
+                                          ( sk(k,j,i)   - sk(k,j-1,i)    )    &
+                                      -      (  5.0_wp * ibit5_s * adv_sca_5  &
+                                          +              ibit4_s * adv_sca_3  &
+                                             ) *                              &
+                                          ( sk(k,j+1,i) - sk(k,j-2,i)    )    &
+                                      +      (           ibit5_s * adv_sca_5  &
+                                             ) *                              &
+                                          ( sk(k,j+2,i) - sk(k,j-3,i)    )    &
+                                                     )
+#else
+                flux_s = swap_flux_y_local(k)
+                diss_s = swap_diss_y_local(k)
+#endif
+
 !
 !--             k index has to be modified near bottom and top, else array
@@ -3558,5 +3721,5 @@
 
 
-                flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                      &
+                flux_t = w(k,j,i) * rho_air_zw(k) * (                         &
                            ( 37.0_wp * ibit8 * adv_sca_5                      &
                         +     7.0_wp * ibit7 * adv_sca_3                      &
@@ -3572,5 +3735,5 @@
                                        )
 
-                diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (              &
+                diss_t = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                 &
                            ( 10.0_wp * ibit8 * adv_sca_5                      &
                         +     3.0_wp * ibit7 * adv_sca_3                      &
@@ -3616,19 +3779,117 @@
 
                 tend(k,j,i) = tend(k,j,i) - (                                 &
-                        ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j) -    &
-                          swap_diss_x_local(k,j)            ) * ddx           &
-                      + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k)   -    &
-                          swap_diss_y_local(k)              ) * ddy           &
-                      + ( ( flux_t(k) + diss_t(k) ) -                         &
-                          ( flux_d    + diss_d    )                           &
-                                                    ) * drho_air(k) * ddzw(k) &
+                        ( ( flux_r + diss_r )                                 &
+                      -   ( flux_l + diss_l ) ) * ddx                         &
+                      + ( ( flux_n + diss_n )                                 &
+                      -   ( flux_s + diss_s ) ) * ddy                         &
+                      + ( ( flux_t + diss_t )                                 &
+                      -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)       &
                                             ) + sk(k,j,i) * div
 
-                swap_flux_y_local(k)   = flux_n(k)
-                swap_diss_y_local(k)   = diss_n(k)
-                swap_flux_x_local(k,j) = flux_r(k)
-                swap_diss_x_local(k,j) = diss_r(k)
-                flux_d                 = flux_t(k)
-                diss_d                 = diss_t(k)
+#ifndef _OPENACC
+                swap_flux_y_local(k)   = flux_n
+                swap_diss_y_local(k)   = diss_n
+                swap_flux_x_local(k,j) = flux_r
+                swap_diss_x_local(k,j) = diss_r
+#endif
+                flux_d                 = flux_t
+                diss_d                 = diss_t
+
+!
+!--             Evaluation of statistics. 
+                SELECT CASE ( sk_num )
+
+                    CASE ( 1 )
+                       !$ACC ATOMIC
+                       sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn)           &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 2 )
+                       !$ACC ATOMIC
+                       sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn)           &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 3 )
+                       !$ACC ATOMIC
+                       sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn)            &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 4 )
+                       !$ACC ATOMIC
+                       sums_wsqcs_ws_l(k,tn)  = sums_wsqcs_ws_l(k,tn)          &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 5 )
+                       !$ACC ATOMIC
+                       sums_wsqrs_ws_l(k,tn)  = sums_wsqrs_ws_l(k,tn)          &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 6 )
+                       !$ACC ATOMIC
+                       sums_wsncs_ws_l(k,tn)  = sums_wsncs_ws_l(k,tn)          &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 7 )
+                       !$ACC ATOMIC
+                       sums_wsnrs_ws_l(k,tn)  = sums_wsnrs_ws_l(k,tn)          &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 8 )
+                       !$ACC ATOMIC
+                       sums_wsss_ws_l(k,tn)  = sums_wsss_ws_l(k,tn)            &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 9 )
+                        !$ACC ATOMIC
+                        sums_salsa_ws_l(k,tn)  = sums_salsa_ws_l(k,tn)         &
+                          + ( flux_t                                           &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t                                           &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+
+                END SELECT
 
              ENDDO
@@ -3636,23 +3897,63 @@
              DO  k = nzb_max+1, nzt
 
-                u_comp    = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
-                flux_r(k) = u_comp * (                                        &
+                u_comp = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
+                flux_r = u_comp * (                                           &
                       37.0_wp * ( sk(k,j,i+1) + sk(k,j,i)   )                 &
                     -  8.0_wp * ( sk(k,j,i+2) + sk(k,j,i-1) )                 &
                     +           ( sk(k,j,i+3) + sk(k,j,i-2) ) ) * adv_sca_5
-                diss_r(k) = -ABS( u_comp ) * (                                &
+                diss_r = -ABS( u_comp ) * (                                   &
                       10.0_wp * ( sk(k,j,i+1) - sk(k,j,i)   )                 &
                     -  5.0_wp * ( sk(k,j,i+2) - sk(k,j,i-1) )                 &
                     +           ( sk(k,j,i+3) - sk(k,j,i-2) ) ) * adv_sca_5
 
-                v_comp    = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
-                flux_n(k) = v_comp * (                                        &
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                u_comp_l = u(k,j,i) - u_gtrans + u_stokes_zu(k)
+                flux_l = u_comp_l * (                                         &
+                                      37.0_wp * ( sk(k,j,i)   + sk(k,j,i-1) ) &
+                                    -  8.0_wp * ( sk(k,j,i+1) + sk(k,j,i-2) ) &
+                                    +           ( sk(k,j,i+2) + sk(k,j,i-3) ) &
+                                               ) * adv_sca_5
+
+                diss_l = -ABS( u_comp_l ) * (                                 &
+                                      10.0_wp * ( sk(k,j,i)   - sk(k,j,i-1) ) &
+                                    -  5.0_wp * ( sk(k,j,i+1) - sk(k,j,i-2) ) &
+                                    +           ( sk(k,j,i+2) - sk(k,j,i-3) ) &
+                                                       ) * adv_sca_5
+#else
+                flux_l = swap_flux_x_local(k,j)
+                diss_l = swap_diss_x_local(k,j)
+#endif
+
+                v_comp = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
+                flux_n = v_comp * (                                           &
                       37.0_wp * ( sk(k,j+1,i) + sk(k,j,i)   )                 &
                     -  8.0_wp * ( sk(k,j+2,i) + sk(k,j-1,i) )                 &
                     +           ( sk(k,j+3,i) + sk(k,j-2,i) ) ) * adv_sca_5
-                diss_n(k) = -ABS( v_comp ) * (                                &
+                diss_n = -ABS( v_comp ) * (                                   &
                       10.0_wp * ( sk(k,j+1,i) - sk(k,j,i)   )                 &
                     -  5.0_wp * ( sk(k,j+2,i) - sk(k,j-1,i) )                 &
                     +           ( sk(k,j+3,i) - sk(k,j-2,i) ) ) * adv_sca_5
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                v_comp_s = v(k,j,i) - v_gtrans + v_stokes_zu(k)
+                flux_s = v_comp_s * (                                        &
+                                    37.0_wp * ( sk(k,j,i)   + sk(k,j-1,i) )  &
+                                  -  8.0_wp * ( sk(k,j+1,i) + sk(k,j-2,i) )  &
+                                  +           ( sk(k,j+2,i) + sk(k,j-3,i) )  &
+                                             ) * adv_sca_5
+                diss_s = -ABS( v_comp_s ) * (                                &
+                                    10.0_wp * ( sk(k,j,i)   - sk(k,j-1,i) )  &
+                                  -  5.0_wp * ( sk(k,j+1,i) - sk(k,j-2,i) )  &
+                                  +             sk(k,j+2,i) - sk(k,j-3,i)    &
+                                                      ) * adv_sca_5
+#else
+                flux_s = swap_flux_y_local(k)
+                diss_s = swap_diss_y_local(k)
+#endif
+
 !
 !--             k index has to be modified near bottom and top, else array
@@ -3667,5 +3968,5 @@
 
 
-                flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                      &
+                flux_t = w(k,j,i) * rho_air_zw(k) * (                      &
                            ( 37.0_wp * ibit8 * adv_sca_5                      &
                         +     7.0_wp * ibit7 * adv_sca_3                      &
@@ -3681,5 +3982,5 @@
                                        )
 
-                diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (              &
+                diss_t = -ABS( w(k,j,i) ) * rho_air_zw(k) * (              &
                            ( 10.0_wp * ibit8 * adv_sca_5                      &
                         +     3.0_wp * ibit7 * adv_sca_3                      &
